// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package chime provides the client and types for making API
// requests to Amazon Chime.
//
// The Amazon Chime API (application programming interface) is designed for
// administrators to use to perform key tasks, such as creating and managing
// Amazon Chime accounts and users. This guide provides detailed information
// about the Amazon Chime API, including operations, types, inputs and outputs,
// and error codes.
//
// You can use an AWS SDK, the AWS Command Line Interface (AWS CLI), or the
// REST API to make API calls. We recommend using an AWS SDK or the AWS CLI.
// Each API operation includes links to information about using it with a language-specific
// AWS SDK or the AWS CLI.
//
// Using an AWS SDKYou don't need to write code to calculate a signature for
// request authentication. The SDK clients authenticate your requests by using
// access keys that you provide. For more information about AWS SDKs, see the
// AWS Developer Center (http://aws.amazon.com/developer/).
//
// Using the AWS CLIUse your access keys with the AWS CLI to make API calls.
// For information about setting up the AWS CLI, see Installing the AWS Command
// Line Interface (http://docs.aws.amazon.com/cli/latest/userguide/installing.html)
// in the AWS Command Line Interface User Guide. For a list of available Amazon
// Chime commands, see the Amazon Chime commands (http://docs.aws.amazon.com/cli/latest/reference/chime/index.html)
// in the AWS CLI Command Reference.
//
// Using REST APIIf you use REST to make API calls, you must authenticate your
// request by providing a signature. Amazon Chime supports signature version
// 4. For more information, see Signature Version 4 Signing Process (http://docs.aws.amazon.com/general/latest/gr/signature-version-4.html)
// in the Amazon Web Services General Reference.
//
// When making REST API calls, use the service name chime and REST endpoint
// https://service.chime.aws.amazon.com.
//
// Administrative permissions are controlled using AWS Identity and Access Management
// (IAM). For more information, see Control Access to the Amazon Chime Console
// (http://docs.aws.amazon.com/chime/latest/ag/control-access.html) in the Amazon
// Chime Administration Guide.
//
// See https://docs.aws.amazon.com/goto/WebAPI/chime-2018-05-01 for more information on this service.
//
// See chime package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/chime/
//
// Using the Client
//
// To contact Amazon Chime with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Amazon Chime client Chime for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/chime/#New
package chime
